/******************************************************************************/
/*   IBM Confidential                                                         */
/*                                                                            */
/*   OCO Source Materials.                                                    */
/*                                                                            */
/*   (C) Copyright IBM Corp. 2001.                                            */
/*                                                                            */
/*   The source code for this program is not published or otherwise           */
/*   divested of its trade secrets, irrespective of what has been             */
/*   deposited with the U.S. Copyright Office.                                */
/*                                                                            */
/*   Product ID:                                                              */
/******************************************************************************/

/**
 * Descriptive Name:  Dump.java
 *
 * Description:
 *
 *
 *    Modifications:
 *
 *    Date      Author                 Category             Defect/Feature
 *              Description
 *
 *  08/08/2001  Dave Been              Creation
 *
 */

package com.ibm.mobileservices.demo;

import com.ibm.mobileservices.lang.SampleCLPmsg;

/**
 */

import javax.microedition.midlet.*;
import javax.microedition.lcdui.Alert;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Choice;
import javax.microedition.lcdui.ChoiceGroup;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.Gauge;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.Item;
import javax.microedition.lcdui.ItemStateListener;
import javax.microedition.lcdui.TextField;
import javax.microedition.lcdui.Ticker;

import java.lang.Exception;

import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;

import java.io.IOException;
import java.io.EOFException;

import java.util.Vector;


import com.ibm.mobileservices.isync.midp.FastRecordStore;
import com.ibm.mobileservices.isync.midp.FastRecordEnumeration;

import javax.microedition.io.Connector;
import javax.microedition.io.InputConnection;
import javax.microedition.io.HttpConnection;

import com.ibm.mobileservices.isync.ISyncProvider;
import com.ibm.mobileservices.isync.ISyncConfigStore;
import com.ibm.mobileservices.isync.ISyncService;

import com.ibm.mobileservices.isync.ISync;
import com.ibm.mobileservices.isync.ISyncDriver;
import com.ibm.mobileservices.isync.midp.MIDPISyncProvider;
import com.ibm.mobileservices.isync.midp.TableMetaData;
import com.ibm.mobileservices.isync.ISyncException;
import com.ibm.mobileservices.isync.event.ISyncEvent;
import com.ibm.mobileservices.isync.event.ISyncListener;
import com.ibm.mobileservices.isync.ISyncSubscriptionSet;

import com.ibm.mobileservices.isync.midp.FastRecordStore;
import com.ibm.mobileservices.isync.sql.Types;

import com.ibm.mobileservices.isync.debug.Debug;

import com.ibm.mobileservices.lang.SampleCLPmsg;

public class Dump extends MIDlet
	implements CommandListener, ItemStateListener
{
	private boolean run_Sync = false;
	/*
		QA related variables
	*/

	byte[] data = new byte[128];

	// MIDP uses HttpConnection
	private HttpConnection httpConn;

	ByteArrayInputStream bin;
	DataInputStream din;

	/*
		old vnurse variables
	*/
	private boolean printedTrace;	// print stack trace once

	private ISyncProvider provider;
	private ISyncService service;
	private ISyncConfigStore config;
	private ISyncDriver isync;			// Sync Client API instance

	private String packetUpSize, packetDownSize;

	private Command backButton;
	private Command exitButton;

	private Command tablesButton;
	private Form tablesForm;
	private ChoiceGroup tableChoice;
	private int tableChoosen = -1;

	private Command showTableButton;

	private Display display;		// The display for this MIDlet
	private Alert errorAlert;
	Form prevForm;
	Form currentForm;
	private Form statusForm;


	public Dump()
	{
		/* 
		 * Set up graphics presentation
		 */

		display 	= Display.getDisplay(this);
		backButton	= new Command("Back", Command.BACK, 2);
		tablesButton	= new Command("Tables", Command.SCREEN, 1);
		showTableButton	= new Command("Dump", Command.SCREEN, 1);
		exitButton = new Command("Exit", Command.SCREEN, 2);

	}

	/**
	 * Start up the MIDlet by creating the TextBox and associating
	 * the exit command and listener.
	 */
	public void startApp()
	{
		if (Debug.DEBUG && Debug.LEVEL > 5)
			System.out.println("        startApp ");
		statusForm = new Form("IBM Sync ");
		statusForm.addCommand(tablesButton);
		statusForm.addCommand(exitButton);

		statusForm.setCommandListener(this);
		prevForm = statusForm;
		display.setCurrent(statusForm);
		currentForm = statusForm;

		try
		{
			Image cs = Image.createImage("/ibm.png");
			statusForm.append(cs);
		}
		catch (IOException ioe) {}


		try
		{
			provider = MIDPISyncProvider.getInstance();
			service = provider.createSyncService("1", "2", "3", "topsecret"); 
			config = service.getConfigStore(null);
			isync = config.getSyncDriver();
		}
		catch (ISyncException neverthrownInMidp)
		{
			System.out.println(" something failed "
				+ neverthrownInMidp.toString());
		}

		String bdate = null;
		try
		{
			bdate = provider.getBuildDate();
		}
		catch (ISyncException neverHappens)
		{
		}
		if (bdate != null)
		{
			statusForm.append("Build date:");
			statusForm.append("\t" + bdate);
		}

		TableMetaData t = ((MIDPISyncProvider) isync).getTableMetaDataByName(SampleCLPmsg.VNMEDICALRECORD);
		if (t == null)
		{
			System.out.println("Cannot find TableMetaData entry in Config for "
				+ SampleCLPmsg.VNMEDICALRECORD);
		}
	}

	private void dumpRecords(String storeName)
	{
		System.out.println(">>>>> <<<<< dumpRecords " + storeName);
		FastRecordStore rms = null;
		try
		{
			rms = FastRecordStore.openRecordStore(storeName, false);
			TableMetaData rs = ((MIDPISyncProvider) isync).getTableMetaDataByName(storeName);

			FastRecordEnumeration enum =
							rms.enumerateRecords(null, null, false);

			while (enum.hasNextElement())
			{
				int id = enum.nextRecordId();
				// if (Debug.DEBUG)
					// System.out.print("readRecords got next id " + id + " " );

				int recSize = -1;
				try
				{
					recSize = rms.getRecordSize(id);
					checkDataSizeOpenStream(recSize);
					recSize = rms.getRecord(id, data, 0);
				}
				catch (Exception e)
				{
					if (Debug.DEBUG)
						System.out.println(e.toString());
					if (Debug.DEBUG && Debug.LEVEL > 8)
						e.printStackTrace();
					break;
				}
				// if (Debug.DEBUG)
					// System.out.println(" len " + recSize);
				String s = null;
				byte dirty = din.readByte();
				String d = "\t";
				if (dirty == ISync.ROW_ADDED)
					d = "INSERTED: ";
				else if (dirty == ISync.ROW_CHANGED)
					d = "CHANGED: ";
				else if (dirty == ISync.ROW_DELETED)
					d = "DELETED: ";

				System.out.print(d);
				displayRecord(rs, din);
			}
		}
		catch (Exception e)
		{
			currentForm.append(e.toString());
			if (Debug.DEBUG)
				System.out.println("dumpRecords: findRecord failed " + e.toString());
			e.printStackTrace();
		}
		finally
		{
			try
			{
				if (rms != null)
					rms.closeRecordStore();
				rms = null;
			}
			catch (Exception e) { }
		}
	}

	private void displayRecord(TableMetaData rs, DataInputStream din)
		throws Exception
	{
		int numCols = rs.getNumCols();
		for (int c = 0; c < numCols; c++)
		{
			boolean nullable = rs.isNullable(c);
			short type = rs.getType(c);

			boolean isNull = false;
			if (nullable)
				isNull = din.readBoolean();
			if (isNull)
			{
				System.out.print("NULL, ");
				continue;
			}

			if (c != 0)
				System.out.print(", ");
			switch (type)
			{
			  case Types.DECIMAL:
			  case Types.CHAR:
			  case Types.VARCHAR:
				String val = din.readUTF();
				System.out.print(val);
				break;
		  	

			  case Types.DATE:
			  {
				int dt = din.readInt();
				String dtStr = fmtDate(dt);
				System.out.print(dtStr);
				break;
			  }
			  case Types.TIME:
			  {
				int tm = din.readInt();
				String tmStr = fmtTime(tm);
				System.out.print(tmStr);
				break;
			  }
			  case Types.INTEGER:
			  {
				int i = din.readInt();
				System.out.print(i);
				break;
			  }

			  case Types.SMALLINT:
			  {
				short s = din.readShort();
				System.out.print(s);
				break;
			  }

			  case Types.TINYINT:
			  {
				byte b = din.readByte();
				System.out.print(b);
				break;
			  }

			  case Types.BIGINT:
			  case Types.TIMESTAMP:
			  {
				long dt = din.readLong();
				System.out.print(dt);
				break;
			  }

			  default:
					System.out.println("\n transferCol unsupported case "
						+ type);
				break;
			}
		}
		System.out.println();
	}
	
	private String fmtTime(int tm)
	{
		int hour = -1, min = -1;

		hour = tm >> 16;
		min = (tm >> 8) & 0xFF;
		int sec = tm & 0xff;

		String hrStr = fmtInt(hour);
		String minStr = fmtInt(min);
		return hrStr + ":" + minStr;
	}
	private String fmtDate(int dt)
	{
		int day = -1, mon = -1, year = -1;

		year = dt >> 16;
		mon = (dt >> 8) & 0xFF;
		day =  dt & 0xFF;

		return new String (mon + "-" + day + "-" + year);
	}
	
	private String fmtInt(int val)
	{
	// System.out.println("fmtInt val " + val);
		if (val < 10)
			return "0" + val;
		else 
			return "" + val;
	}
	private void checkDataSizeOpenStream(int recSize)
		throws IOException
	{
		if (recSize <= data.length)
		{
			// open streams if required 
			if (bin == null)
				openStreams(data);

			// reset to start of data
			((InputStream) din).reset();
		    return;
		}

		data = new byte[recSize + 40];	// plan ahead, add 40

		// open on new data byte array
		if (din != null)
			((InputStream) din).close();

		openStreams(data);
	}
	private void openStreams(byte data[])
	{
		bin = new ByteArrayInputStream(data);
		din = new DataInputStream(bin);
	}
	
    public int eventIssued(ISyncEvent syncEvent)
    {
		return 0;
    }
	public void pauseApp() {
	}

	/**
	 * Destroy must cleanup everything not handled by the garbage collector.
	 * In this case there is nothing to cleanup.
	 */
	public void destroyApp(boolean unconditional)
	{
		if (isync != null)
		{
			try
			{
				isync.close();
			}
			catch (Exception e) { }
			isync = null;
		}
	}
	/*
	 * Respond to commands, including exit
	 * On the exit command, cleanup and notify that the MIDlet has been destroyed.
	 */
	public void commandAction(Command c, Displayable s)
	{
		System.out.println("commandAction " + c + " s " + s);
		if (c == exitButton)
		{
			destroyApp(false);
			notifyDestroyed();
			return;
		}
		if (c == backButton)
		{
			display.setCurrent(statusForm);
			statusForm.setCommandListener(this);
			return;
		}

		if (c == tablesButton)
		{
			pickTables();
			return;
		}
		if (c == showTableButton)
		{
			String table = stores[tableChoosen];
			System.out.println(" show Table " + table);
			dumpRecords(table);
		}
	}

	private String[] stores = {SampleCLPmsg.VNPERSON,
						SampleCLPmsg.VNMEDICALRECORD, SampleCLPmsg.VNCONTACT,
						SampleCLPmsg.VNSCHEDULE};

	private void pickTables()
	{
		tableChoosen = 0;
		try
		{
			tableChoice = showChoiceGroup(stores, tablesForm, "View Table",
				"Pick one:");
		}
		catch (Exception e)
		{
			System.out.println("show Table Choices failed " + e.toString());
		}
	}

	private ChoiceGroup showChoiceGroup(
		String[] choices, Form form, String formTitle,
		String choiceTitle)
			throws Exception
	{
		if (Debug.DEBUG)
			System.out.println("showChoiceGroup " + formTitle + " " + choiceTitle);

		if (form == null)
		{
			form = new Form(formTitle);
			form.setCommandListener(this);
			form.setItemStateListener(this);
		}
		else
		{
			for (int i = form.size() - 1; i >= 0; i--)
				form.delete(i);
		}
		currentForm = form;

		ChoiceGroup choice = null;
		if (choices == null)
			currentForm.append("Nothing found in database");
		else
		{
			try
			{
				choice = new ChoiceGroup(
					choiceTitle, Choice.EXCLUSIVE, choices, null);
			}
			catch (Exception e)
			{
				if (Debug.DEBUG)
					System.out.println(" choiceGroup failed " + e.toString());
				if (Debug.DEBUG && Debug.LEVEL > 8)
					e.printStackTrace();
				throw e;
			}

			form.append(choice);
		}

		form.addCommand(backButton);
		form.addCommand(showTableButton);

		display.setCurrent(form);

		return choice;
	}

	/**
	 * Handle Choice Group, etc state change messages
	 */
	public void itemStateChanged(Item item)
	{
		if (Debug.DEBUG)
			System.out.println("itemStateChanged: " + item);

		if (item instanceof ChoiceGroup)
		{
			ChoiceGroup cg = (ChoiceGroup) item;
			int index = cg.getSelectedIndex();

			if (cg == tableChoice)
			{
				tableChoosen = index;
				if (Debug.DEBUG)
					System.out.println("tableChoice: tableChoosen is " + tableChoosen);
			}
		}
	}
}
